use uefi::{
    prelude::BootServices, proto::loaded_image::LoadedImage, table::boot::ScopedProtocol, Handle,
};

use crate::Result;

pub struct Context<'a> {
    handle: Handle,
    image: ScopedProtocol<'a, LoadedImage>,
    boot_services: &'a BootServices,
}

impl<'a> Context<'a> {
    pub fn new(handle: Handle, boot_services: &'a BootServices) -> Result<Self> {
        let image = boot_services.open_protocol_exclusive::<LoadedImage>(handle)?;

        Ok(Self {
            handle,
            boot_services,
            image,
        })
    }
}
